﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Telerik.Web.UI;
using System.Collections;

namespace FilterEditors
{
    public class MyEditor : RadFilterDataFieldEditor
    {
        protected override void CopySettings(RadFilterDataFieldEditor baseEditor)
        {
            base.CopySettings(baseEditor);
            var editor = baseEditor as MyEditor;
            if (editor != null)
            {
                StartDate = editor.StartDate;
            }
        }

        public DateTime? StartDate { get; set; }

        public override Type DataType
        {
            get
            {
                return typeof(DateTime);
            }
            set
            {
                //base.DataType = value;
            }
        }

        public override System.Collections.ArrayList ExtractValues()
        {
            ArrayList list = new ArrayList();
            if (combo.SelectedIndex == 0)
            {
                list.Add(null);
            }
            else
            {
                list.Add(DateTime.Parse(combo.SelectedValue));
            }

            return list;
        }

        RadComboBox combo;
        public override void InitializeEditor(System.Web.UI.Control container)
        {
            var currentDate = StartDate ?? DateTime.Now;
            combo = new RadComboBox();
            combo.Items.Add(new RadComboBoxItem("--Choose--"));
            combo.Items.Add(new RadComboBoxItem("One Week", currentDate.AddDays(7*1).ToString()));
            combo.Items.Add(new RadComboBoxItem("Two Weeks", currentDate.AddDays(7*2).ToString()));            

            container.Controls.Add(combo);
        }

        public override void SetEditorValues(System.Collections.ArrayList values)
        {
            if (values[0] != null)
            {
                combo.SelectedValue = values[0].ToString();
            }
        }
    }
}